# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 3 * 1e6 + 1;
const int INF = 1e9;
int N;
int A[MAXN];
int Answer = INF;
int LTree[MAXN];
int RTree[MAXN];
int SlideL[MAXN];
int SlideR[MAXN];

void UpdateL(int Index)
{
    while(Index >= 1)
    {
        LTree[Index]++;
        Index -= (Index & (-Index));
    }
}

int SumL(int Index)
{
    int Sum = 0;

    while(Index <= N)
    {
        Sum += LTree[Index];
        Index += (Index & (-Index));
    }

    return Sum;
}

void UpdateR(int Index)
{
    while(Index <= N)
    {
        RTree[Index]++;
        Index += (Index & (-Index));
    }
}

int SumR(int Index)
{
    int Sum = 0;

    while(Index >= 1)
    {
        Sum += RTree[Index];
        Index -= (Index & (-Index));
    }

    return Sum;
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;
    for(int i = 0; i < N; i++) cin >> A[i];
}

void Solve()
{
    int Current = 0;

    for(int i = 0; i < N; i++)
    {
        SlideL[A[i]] = SumL(A[i] + 1);
        Current += SlideL[A[i]];
        UpdateL(A[i]);
    }

    for(int i = N - 1; i >= 0; i--)
    {
        SlideR[A[i]] = SumR(A[i] - 1);
        UpdateR(A[i]);
    }

    for(int i = 1; i <= N; i++)
    {
        Current -= SlideL[i];
        Answer = min(Answer, Current);
        Current += SlideR[i];
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
