# include <iostream>
using namespace std;

const int MAX=3e6+11;

int n;
int a[MAX];

struct Fenwick
{
    int tree[MAX];

    void init()
    {
        for(int i=1;i<=n;i++)
        {
            tree[i]=0;
        }
    }

    void update(int pos, int d)
    {
        for(int i=pos;i<=n;i=(i|(i+1)))
        {
            tree[i]+=d;
        }
    }

    int query(int pos)
    {
        int ans=0;
        for(int i=pos;i>=1;i=(i&(i+1))-1)
        {
            ans+=tree[i];
        }
        return ans;
    }

    int query(int l, int r)
    {
        if(l>r) return 0;
        return query(r)-query(l-1);
    }
}tree;

long long inv_le[MAX];
long long inv_ri[MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];

    tree.init();
    for(int i=1;i<=n;i++)
    {
        inv_le[a[i]]=tree.query(a[i]+1,n);
        tree.update(a[i],1);
    }

    tree.init();
    for(int i=n;i>=1;i--)
    {
        inv_ri[a[i]]=tree.query(1,a[i]-1);
        tree.update(a[i],1);
    }

    long long ans=1e18;
    for(int p=1;p<=n;p++)
    {
        long long curr_ans=0;
        for(int i=1;i<p;i++) curr_ans+=inv_ri[i];
        for(int i=p+1;i<=n;i++) curr_ans+=inv_le[i];
        ans=min(ans,curr_ans);
    }

    cout<<ans<<"\n";

    return 0;
}
