# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;

const long long MOD=1e9+7;
const int MAX=1e5+11,LOG=18;

int n,m;
vector<int> adj[MAX];

void read()
{
    cin>>n>>m;
    for(int i=1;i<n;i++)
    {
        int u,v;
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
}

int h[MAX];
int up[MAX][LOG];

void dfs_h(int curr, int par)
{
    for(int nxt: adj[curr])
    {
        if(nxt==par) continue;

        h[nxt]=h[curr]+1;
        up[nxt][0]=curr;
        dfs_h(nxt,curr);
    }
}

void prepare_lca()
{
    dfs_h(1,0);
    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            if(h[i]-(1<<j)<0) continue;
            up[i][j]=up[up[i][j-1]][j-1];
        }
    }
}

int lift(int curr, int power)
{
    for(int j=LOG-1;j>=0;j--)
    {
        if((1<<j)<=power)
        {
            curr=up[curr][j];
            power-=(1<<j);
        }
    }
    return curr;

    while(power--)
    {
        curr=up[curr][0];
    }
    return curr;
}

int get_lca(int u, int v)
{
    if(h[u]<h[v]) swap(u,v);

    for(int j=LOG-1;j>=0;j--)
    {
        if(h[u]-(1<<j)>=h[v])
        {
            u=up[u][j];
        }
    }

    if(u==v) return u;

    for(int j=LOG-1;j>=0;j--)
    {
        if(h[u]-(1<<j)>=0 and up[u][j]!=up[v][j])
        {
            u=up[u][j];
            v=up[v][j];
        }
    }
    return up[u][0];
}

vector<pair<int,int>> adj2[MAX];

void req()
{
    bool fall=0;
    while(m--)
    {
        int u,v;
        cin>>u>>v;

        int lca=get_lca(u,v);
        if(lca!=u and lca!=v)
        {
            int u2=lift(u,h[u]-h[lca]-1);
            int v2=lift(v,h[v]-h[lca]-1);
            adj2[lca].push_back({u2,v2});

            //cout<<"->"<<u2<<" "<<v2<<"\n";
            //cout<<"->"<<lca<<"\n";
        }

        if(lca==v) fall=1;
    }

    if(fall)
    {
        cout<<0<<"\n";
        exit(0);
    }
}

long long dp[MAX];
long long cnt[MAX];
int num[MAX];
int bef[MAX];
bool edg[13][13];

void dfs(int curr, int par)
{
    int ch=0;
    long long ans=1;
    for(int nxt: adj[curr])
    {
        if(nxt==par) continue;

        num[nxt]=ch;
        ch++;
        dfs(nxt,curr);
        ans=(ans*dp[nxt])%MOD;
    }

    if(ch==0)
    {
        dp[curr]=ans;
        return ;
    }

    /*
    for(int i=0;i<ch;i++) bef[i]=0;
    for(int i=0;i<(1<<ch);i++) cnt[i]=0;
    cnt[0]=1;

    for(pair<int,int> pa: adj2[curr])
    {
        int u=num[pa.first],v=num[pa.second];
        bef[v]+=(1<<u);
    }

    for(int mask=0;mask<(1<<ch);mask++)
    {
        if(cnt[mask]==0) continue;

        for(int put=0;put<ch;put++)
        {
            if((mask&(1<<put))!=0) continue;
            if((mask&bef[put])!=bef[put]) continue;

            cnt[mask+(1<<put)]+=cnt[mask];
            cnt[mask+(1<<put)]%=MOD;
        }
    }

    dp[curr]=(ans*cnt[(1<<ch)-1])%MOD;
    */

    for(int i=0;i<ch;i++)
    {
        for(int j=0;j<ch;j++) edg[i][j]=0;
    }

    for(pair<int,int> pa: adj2[curr])
    {
         int u=num[pa.first],v=num[pa.second];
         edg[u][v]=1;
    }

    long long br=0;
    vector<int> v;
    for(int i=0;i<ch;i++) v.push_back(i);
    do
    {
        bool f=1;
        for(int i=0;i<ch;i++)
        {
            for(int j=i+1;j<ch;j++)
            {
                if(edg[v[j]][v[i]]) f=0;
            }
        }

        if(f) br++;

    }while(next_permutation(v.begin(),v.end()));

    dp[curr]=(ans*br)%MOD;
}

void solve()
{
    dfs(1,0);
    cout<<dp[1]<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    prepare_lca();
    req();
    solve();

    return 0;
}

/*
3 2
1 2
1 3
2 3
3 2
*/
