# include <iostream>
# include <algorithm>
# include <vector>
using namespace std;

const long long INF=1e18;
const int MAX=2e3+11;

long long n,m;

struct pro
{
    long long t,k,id;

    bool friend operator < (pro A, pro B)
    {
        if(A.t!=B.t) return A.t<B.t;
        return A.k<B.k;
    }
}a[MAX];

struct node
{
    long long d,vz;
    node(){d=1;vz=0;}
    node(long long _d, long long _vz) {d=_d;vz=_vz;}
    bool friend operator < (node A, node B)
    {
        if(A.d!=B.d) return A.d<B.d;
        return A.vz<B.vz;
    }
};

node nxt(node A, long long br)
{
        node res=A;
        res.vz+=br;
        res.d+=res.vz/m;
        res.vz%=m;
        return res;
}

bool expired(node A, pro B)
{
        if(A.vz==0) return A.d-1<=B.t;
        return A.d<=B.t;
}

node dp[MAX][MAX];
node bst[MAX][MAX];
int bst_id[MAX][MAX];
int pr[MAX][MAX];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i].t>>a[i].k;
        a[i].id=i;
    }

    sort(a+1,a+n+1);

    bst[0][1]={INF,INF};
    for(int i=1;i<=n;i++)
    {
        node curr=nxt({1,0},a[i].k);
        if(!expired(curr,a[i])) dp[i][1]=curr;
        else dp[i][1]={INF,INF};

        if(bst[i-1][1]<dp[i][1])
        {
            bst[i][1]=dp[i][1];
            bst_id[i][1]=i;
        }
        else
        {
            bst[i][1]=bst[i-1][1];
            bst_id[i][1]=bst_id[i-1][1];
        }
    }

    for(int j=2;j<=n;j++)
    {
        bst[0][j]={INF,INF};
        for(int i=1;i<=n;i++)
        {
            dp[i][j]={INF,INF};
            if(bst[i-1][j-1].d!=INF)
            {
                node curr=bst[i-1][j-1];
                curr=nxt(curr,a[i].k);
                if(!expired(curr,a[i]))
                {
                    dp[i][j]=curr;
                    pr[i][j]=bst_id[i-1][j-1];
                }

                if(bst[i-1][j]<dp[i][j])
                {
                    bst[i][j]=dp[i][j];
                    bst_id[i][j]=i;
                }
                else
                {
                  bst[i][j]=bst[i-1][j];
                  bst_id[i][j]=bst_id[i-1][j];
                }
            }
        }
    }

    int ans=0,start=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(dp[i][j].d!=INF)
            {
                if(j>ans)
                {
                    ans=j;
                    start=i;
                }
            }
        }
    }

    cout<<ans<<"\n";
    while(ans>0)
    {
        cout<<start<<" ";
        start=pr[ans][start];
        ans--;
    }
    cout<<"\n";

    return 0;
}



