#include<bits/stdc++.h>
using namespace std;
const long long MAX_N = 200000;
const long long MAX_K = 1e18 + 1;
long long tree[4 * MAX_N];
struct Provision
{
    long long day;
    long long quantity;
    long long product_number;
};
Provision provisions[MAX_N];
void build(long long node, long long tl, long long tr)
{
    if(tl == tr)
    {
        tree[node] = provisions[tl - 1].quantity;
    }
    else
    {
        long long mid = (tl + tr) / 2;
        build(node * 2, tl, mid);
        build(node * 2  + 1, mid + 1, tr);
        tree[node] = min(tree[node * 2], tree[node * 2 + 1]);
    }
}
void update(long long node, long long tl, long long tr)
{
    if(tl == tr)
    {
        tree[node] = MAX_K;
    }
    else
    {
        long long mid = (tl + tr) / 2;
        if(tree[node * 2] <= tree[node * 2 + 1])
        {
            update(node * 2, tl, mid);
        }
        else
        {
            update(node * 2 + 1, mid + 1, tr);
        }
        tree[node] = min(tree[node * 2], tree[node * 2 + 1]);
    }
}
long long query(long long node, long long tl, long long tr)
{
    if(tl == tr)
    {
        return tl;
    }
    else
    {
        long long mid = (tl + tr) / 2;
        if(tree[node * 2] <= tree[node * 2 + 1])
        {
            return query(node * 2, tl, mid);
        }
        else
        {
            return query(node * 2 + 1, mid + 1, tr);
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long N, M, t, k;
    cin>>N>>M;
    bool equal_t = true;
    for(long long i = 0; i < N; i++)
    {
        cin>>t>>k;
        provisions[i].day = t;
        provisions[i].product_number = i + 1;
        provisions[i].quantity = k;
        if(t != provisions[i-1].day && i >= 1)
        {
            equal_t = false;
        }
    }
    if(N == 1)
    {
        if(M * provisions[0].day < provisions[0].quantity)
        {
            cout<<"0"<<endl;
        }
        else
        {
            cout<<"1"<<endl<<"1"<<endl;
        }
    }
    else
    {
        if(equal_t == true)
        {
            vector<long long> pos_ans;
            long long provisions_counter = 0;
            long long type_counter = 0;
            long long query_ans;
            build(1, 1, N);
            while(M * t >= provisions_counter)
            {
                query_ans = query(1, 1, N);
                if(M * t - provisions_counter >= provisions[query_ans - 1].quantity)
                {
                    type_counter++;
                    provisions_counter += provisions[query_ans - 1].quantity;
                    pos_ans.push_back(query_ans);
                    update(1, 1, N);
                }
                else
                {
                    break;
                }
            }
            cout<<type_counter<<endl;
            if(type_counter > 0)
            {
                for(long long i = 0; i < pos_ans.size(); i++)
                {
                    if(i != 0)
                    {
                        cout<<" ";
                    }
                    cout<<pos_ans[i];
                }
                cout<<endl;
            }
        }
    }
    return 0;
}
